###########################################################################
#			RPM Package config file for Aubit 4gl
#
###########################################################################

#
# $Id: aubit-rpm.spec.in,v 1.27 2006/12/01 06:52:59 afalout Exp $
#

#--------------------------------------------------------------------------
# TODO:
# - create signature
# - use RedHat plugin for Eclipse for edidting this file
# - Use RPMlint
# - separate all plug-ins to separate rpm's so we can enable dependencies
# - mark license and readme files as --percent--license and --percent--readme
# - use --with-xx & --without-xx to allow user to change A4GL_USER_INTERACTION
#   and output verbosity
# - verify prereqs for both install and build
# - #TODO - we should create user & group aubit, so we dont use root here
#
#--------------------------------------------------------------------------

#--------------------------------------------------------------------------
# NOTES:
# - See /usr/lib/rpm for available macros
# - WARNING - RPM is a system intentionally designed to NOT have user intractions
# - According to some RedHat developers, "rpm is an evil hack. <shrug>" And I 
#   cant help but agree. Allways remember that RefHat created it as packaging
#   for there OS - and not for application distribution. It sucs big time and if 
#   it was not in LSB specification, I would rather be having a root canal then
#   trying to make this work :-(
#--------------------------------------------------------------------------

#--------------------------------------------------------------------------
# (replace --percent-- with real percent sign - must hide it as comments dont 
# work here)
#
# Interesting macros maybe for future use:
#
# macro: --percent--suse_update_desktop_file
#     Used to add easily a category to .desktop files according to XDG
#     standard. see /usr/lib/rpm/suse_update_desktop_file.sh
#
#Prints to stderr
#	--percent--{echo:Performing post-install tasks...}
#
#Prints message to stderr and returns BADSPEC
#	--percent--{error:nessage}
#
#Print warning to stderr
#	--percent--{warn:this and that}
#
#--percent--if --percent--build_qsa
#--percent--exclude --percent--_libdir/libqsa.so.*
#--percent--endif

#--with-xxx --without-xx

#--------------------------------------------------------------------------


###################
#Variables section
#--------------------------------------------------------------------------
#
# WARNING! WARNING! WARNING! commenting out lines in this section WILL BE 
# IGNORED AND THERE CONTENT PROCESSED REGARDLESS!!!!! So when you want to 
# comment out any line containing percentage sign, use '--percent--' instead.
#
# User can override this variables when running rpm by using ...TODO...
#
#--------------------------------------------------------------------------
# As RPM demands root privilege to install anything, it is pointless to 
# install anything not available system-wide. User can specify a --prefix flag to 
# rpm to relocate it to some other place. 
#
# Added -rpm to file name to avoid clashing with other types of installation (tarball, autopackage...)
#
#Note that rpm adjusts RPM_INSTALL_PREFIX[n] variable to account for user possibly
#using --prefix flag, so this is only the DEFAULT and not nececeraly the acutall
#location where we will install

%define RPM_A4GL_RPMINSTALL_LOG		/tmp/aubit4gl-rpminstall.log
%define RPM_A4GL_RPMDEINSTALL_LOG	/tmp/aubit4gl-rpmdeinstall.log
%define RPM_A4GL_RPMVERIFY_LOG		/tmp/aubit4gl-rpmverify.log
%define RPM_MAKE					gmake
%define A4GL_USER_INTERACTION		1
%define RPM_A4GL_DEBUG				1
#Change to 'test' to silence:
%define RPM_A4GL_VERBOSE			test
%define RPM_A4GL_ERROR				echo
%define RPM_A4GL_EXIT				echo
#Change to 'test' to prevent exit
%define RPM_A4GL_ERROR_EXIT			exit
%define RPM_A4GL_ERROR_EXIT_CODE	0

#-------------------------------
#	The sub-directory (relative to --percent--{_builddir}  
#    which is defined as --percent--_builddir		--percent--{_topdir}/BUILD) 
#	where sources are compiled.
#	This macro is set after processing --percent--setup, either explicitly from the
#	value given to -n or the default name-version.
#
%define buildsubdir %{name}src-1.00-24

#Just testing - defining a macro :
#	--percent--define myPatch() patch --percent--{-p:-p--percent--{-p*}}
#	--percent--define testfunc() echo "param to testfunc was --percent--1 --percent--2 --percent--3"
#
# Calling a custom defined macro:
#	--percent--testfunc A 1 B

#--------------------------------------------------------------------------
#There may be times when RPM's automatic dependency processing is not
#desired. In these cases, the autoreqprov tag may be used to disable it.
#This tag takes a yes/no or 0/1 value. For example, to disable automatic
#dependency processing, the following line may be used:
#This is needed in case of Aubit, because otherwise all dependencies for
#all plug-ins like GTK+ unixODBC, iODBC, ESQL/C, PDFlib, wtc, will be defined
#as prerequisites for installing Aubit, which is not true, since Aubit can
#be configured to use this extensions only if they are installed on target 
#system
AutoReqProv: no
#--------------------------------------------------------------------------

##############
#Description
##############
Summary: Aubit 4GL compiler
Name: aubit4gl
Version: 1.00.24
Release: 1
License: GNU GPL/LGPL
Vendor: Aubit project development team
Packager: Andrej Falout <andrej@falout.org>
Group: Development/Languages
URL: http://aubit4gl.sf.net
Distribution: Red Hat Contrib-Net
BuildArchitectures: i686

#-------------------------------
#FIXME: Icon tag accepts only GIF or XPM formats ?
#We dont care anymore, as we install it using 'aubit' script
#Icon: /usr/local/aubit4gl/docs/aubit4gl.png

#-------------------------------
#Provides is supposed to specify a capability needed by other packages,
#that can be provided by more then one package. For instance, both 4Js BDL,
#Querix Hydra, and Informix RDS provide Informix-4gl compatible compiler.
Provides: x4gl_compiler

#-------------------------------
#Finding  Requires: (using /usr/lib/rpm/find-requires)...
#TODO - verify this
Requires: glibc >= 2.2, glibc-devel >= 2.2, /bin/bash
BuildRequires: glibc >= 2.2, glibc-devel >= 2.2, /bin/bash, gmake, gawk, sed

#-------------------------------
#Define place where RPM build will be done; defines env var RPB_BUILD_ROOT
#override with 'rpmbuild --buildroot'
#Note: when running 'rpmbuild -bl' it checks for existance of files specified in
#this file under RPM_BUILD_ROOT. 
#If not defined, defualts to nothing - so it expects listed files under file
#system root. Therefore, for convinience, we specify same location where
#'make install' would install compiled binaries. In configure.in, this is controled
#with RPM_ABSOLUTE variable
#BuildRoot: /usr/local/aubit4gl
#BuildRoot: --percent--{_tmppath}/--percent--{name}---percent--{version}-rpmbuildroot

#-------------------------------
# Location where RPM gets installed by default on the targets system
# user can override using 'rpm -i --prefix /some/path xxx.rpm'
# this is default only - actuall installation location is automatically set
# in variable RPM_INSTALL_PREFIX[n]
# Acutally... this is just a tag so that rpm know WHICH PART OF THE FILE NAME
# listed under 'files' section to replace when user specifies --prefix
# SO that means that paths listed in 'files' section MUST have the same
# part added!
Prefix: /opt/aubit4gl-rpm

#--------------------------------
# Do we care?
#We dont want our doc files to get installed using RPM conventions outside our
#tree so we will redefine destination for them:
# this is default only - actuall installation location is automatically set
#in variable RPM_INSTALL_PREFIX[n]
#RPM includes /usr/doc /usr/info and /usr/man in --percent--docdir by default
#OH CRAP THIS IS NOT WHAT ONE WOULD EXPECT... AGAIN!!!!
#%docdir %{RPM_INSTALL_PREFIX0}/docs


#-------------------------------
#WARNNING: file name used here will need to be present on local system
#at time of building RPM:
Source: http://aubit4gl.sf.net/files/%{name}src-1.00-24.zip

##############
%description
##############
#--------------------------------------------------------------------------
Aubit 4gl (Fourth Generation programing Language) compiler compiles source
files to several low-level programming languages (C, Perl, Java...). It has
conectivity to many databases, several UI interfaces and many features.

Install Aubit compiler if you want to write new or compile existing Business 
Related Database Oriented (BRDO) applications.

See http://aubit4gl.sf.net for documentation
#--------------------------------------------------------------------------

##############
%prep
##############
%{RPM_A4GL_VERBOSE} "Processing 'prep' section..."

#Seems that setup macro is useless anyway, and can be ommited, but we need
#it if we want to override buildsubdir to avoid manual cd-in and having to 
#add buildsubdir in front of all --percent--doc macros
%setup -q -n %buildsubdir

%{RPM_A4GL_VERBOSE} "Finished processing 'prep' section."

##############
%build
##############
%{RPM_A4GL_VERBOSE} "Processing 'build' section..."
./configure
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS"
#CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr
%{RPM_A4GL_VERBOSE} "Finished processing 'build' section."

##############
%install
##############
%{RPM_A4GL_VERBOSE} "Processing 'install' section..."
#install -s -m 755 -o 0 -g 0 loadmap /usr/bin/loadmap
#install -m 644 -o 0 -g 0 eject.1 /usr/man/man1
make install PREFIX="/opt/aubit4gl-rpm"

# If rpmbuild finds any installed, but unpackaged files, it will stop, so
# delete the files and/or dirs from RPM_BUILD_ROOT that you do not want to 
# package up:
# We just deleted crucial link and left Aubit unusable...(unless user installing it was root
# so another one is in /usr/lib)

   rm -f ${RPM_BUILD_ROOT}/lib/libaubit4gl.so ${RPM_BUILD_ROOT}/etc/config/.cvsignore
   rm -rf ${RPM_BUILD_ROOT}/etc/config/CVS

%{RPM_A4GL_VERBOSE} "Finished processing 'install' section."

##############
#--percent--clean
##############
#%{RPM_A4GL_VERBOSE} "Processing 'clean' section..."
#[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf "$RPM_BUILD_ROOT"
#%{RPM_A4GL_VERBOSE} "Finished processing 'clean' section."

##############
%files
##############
#NOTE: cannot have any shell commands in this section

#Default file atributes to be applied to installed files:
#Allows you to set default attributes for files listed after the defattr 
#declaration. The attributes are listed in the form (mode, owner, group) where 
#the mode is the octal number representing the bit pattern for the new permissions 
#(like chmod would use), owner is the username of the owner, and group is the 
#group you would like assigned. You may leave any field to the installed default 
#by simply placing a - in its place, as was done in the mode field for the example 
#package.
#TODO - we should create user & group aubit, so we dont use root here
%defattr(-,root,root)

#Various files that will be created depending on system configuration, defined
#from configure: (RPMFILE_x)
/opt/aubit4gl-rpm/plugins-1.00_24/libLEX_PCODEC.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libLEX_PERL.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libUI_HL_TUIN.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libUI_HL_TUIw.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libUI_HL_TUINs.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libUI_HL_TUIws.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libSQL_esql.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libESQL_INFORMIX.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libSQL_odbc32.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libSQL_pg.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libSQL_pg8.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libMENU_GENERIC.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libUI_HL_GTK.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libLOGREP_CSV.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libLOGREP_TXT.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libUI_GLADE.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libA4GL_glade.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libSQL_sqlite3.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libESQL_POSTGRES.dll































#--end--

#Shared libraries: (LIBFILE_x)
/opt/aubit4gl-rpm/lib/libaubit4gl-1.00_24.dll

/opt/aubit4gl-rpm/plugins-1.00_24/libLEX_EC.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libLEX_C.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libLEX_CS.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libHELP_std.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libA4GL_string.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libchannel.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libA4GL_file.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libEXREPORT_NOPDF.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libRPC_NORPC.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libFORM_NOFORM.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libSQL_nosql.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libMENU_NOMENU.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libMSG_NATIVE.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libUI_CONSOLE.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libPACKER_PACKED.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libPACKER_PERL.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libPACKER_XML.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libFORM_GENERIC.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libDATA_menu_list.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libDATA_report.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libDATA_module.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libDATA_struct_form.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libPACKER_MEMPACKED.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libSQL_FILESCHEMA.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libSQLPARSE_NONE.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libSQLPARSE_INFORMIX.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libLOGREPPROC_TXT.dll
/opt/aubit4gl-rpm/plugins-1.00_24/libLOGREPPROC_CSV.dll










#--end--

#executables: (EXEFILE_x)
/opt/aubit4gl-rpm/bin/4glc.exe
/opt/aubit4gl-rpm/bin/fcompile.exe
/opt/aubit4gl-rpm/bin/amkmessage.exe
/opt/aubit4gl-rpm/bin/convertsql.exe
/opt/aubit4gl-rpm/bin/4glpc.exe
/opt/aubit4gl-rpm/bin/sql_parse.exe
/opt/aubit4gl-rpm/bin/adbschema.exe
/opt/aubit4gl-rpm/bin/asql_g.4ae
/opt/aubit4gl-rpm/bin/aace.exe
/opt/aubit4gl-rpm/bin/generate_aace.exe
/opt/aubit4gl-rpm/bin/aace_4gl.exe
/opt/aubit4gl-rpm/bin/aace_perl.exe
/opt/aubit4gl-rpm/bin/mcompile.exe
/opt/aubit4gl-rpm/bin/mdecompile.exe
/opt/aubit4gl-rpm/bin/process_report.exe
/opt/aubit4gl-rpm/bin/adecompile.exe
/opt/aubit4gl-rpm/bin/ide1.4ae
/opt/aubit4gl-rpm/bin/fdecompile.exe
/opt/aubit4gl-rpm/bin/unmkmessage.exe
/opt/aubit4gl-rpm/bin/default_frm.exe
/opt/aubit4gl-rpm/bin/aupscol.exe
/opt/aubit4gl-rpm/bin/adbload2.exe
/opt/aubit4gl-rpm/bin/asql_i.4ae
/opt/aubit4gl-rpm/bin/runforms.4ae
/opt/aubit4gl-rpm/bin/asql_p.4ae
/opt/aubit4gl-rpm/bin/c2pcode_fgl.exe
/opt/aubit4gl-rpm/bin/checker_fgl.exe
/opt/aubit4gl-rpm/bin/runner_fgl.exe
/opt/aubit4gl-rpm/bin/link_fgl.exe
/opt/aubit4gl-rpm/bin/afinderr.exe
/opt/aubit4gl-rpm/bin/configurator.exe
/opt/aubit4gl-rpm/bin/aubit-config.exe
/opt/aubit4gl-rpm/bin/fshow.exe
/opt/aubit4gl-rpm/bin/loadmap.exe
/opt/aubit4gl-rpm/bin/layout_engine.exe
/opt/aubit4gl-rpm/bin/report_viewer.exe














#--end--

#Shell scripts: (SHFILE_x)
/opt/aubit4gl-rpm/bin/aubit
/opt/aubit4gl-rpm/bin/ecpg_wrap
/opt/aubit4gl-rpm/bin/amake
/opt/aubit4gl-rpm/bin/genmake
/opt/aubit4gl-rpm/bin/prepmake
/opt/aubit4gl-rpm/bin/runner_fgl_wrapper
/opt/aubit4gl-rpm/configure
/opt/aubit4gl-rpm/bin/4GL_metrics.cgi
/opt/aubit4gl-rpm/bin/shtool











#--end--

#Include files: (INCFILE_x)
/opt/aubit4gl-rpm/incl/a4gl_incl_4glhdr.h
/opt/aubit4gl-rpm/incl/a4gl_incl_4gldef.h
/opt/aubit4gl-rpm/incl/a4gl_4gl_callable.h
/opt/aubit4gl-rpm/incl/a4gl_rep_structure.h
/opt/aubit4gl-rpm/incl/a4gl_screenio.h
/opt/aubit4gl-rpm/incl/a4gl_exdata.h
/opt/aubit4gl-rpm/incl/a4gl_API_exreport.h
/opt/aubit4gl-rpm/incl/a4gl_API_form.h
/opt/aubit4gl-rpm/incl/a4gl_API_help.h
/opt/aubit4gl-rpm/incl/a4gl_API_menu.h
/opt/aubit4gl-rpm/incl/a4gl_API_rpc.h
/opt/aubit4gl-rpm/incl/a4gl_API_sql.h
/opt/aubit4gl-rpm/incl/a4gl_API_ui.h
/opt/aubit4gl-rpm/incl/a4gl_expr.h
/opt/aubit4gl-rpm/incl/a4gl_API_sqlparse.h
/opt/aubit4gl-rpm/incl/a4gl_API_esql.h
/opt/aubit4gl-rpm/incl/a4gl_incl_infx.h
/opt/aubit4gl-rpm/incl/a4gl_incl_config.h
/opt/aubit4gl-rpm/incl/a4gl_esql.h
/opt/aubit4gl-rpm/incl/a4gl_esql_infx.h
/opt/aubit4gl-rpm/incl/a4gl_esql_postgres.h
/opt/aubit4gl-rpm/incl/a4gl_esql_ingres.h
/opt/aubit4gl-rpm/incl/a4gl_memhandling.h
/opt/aubit4gl-rpm/incl/a4gl_esql_infoflex.h
/opt/aubit4gl-rpm/incl/header.mki
/opt/aubit4gl-rpm/incl/footer.mki
/opt/aubit4gl-rpm/incl/footer2.mki
/opt/aubit4gl-rpm/incl/footer-c.mki
/opt/aubit4gl-rpm/incl/a4gl.mk
/opt/aubit4gl-rpm/incl/q4gl.mk
/opt/aubit4gl-rpm/incl/d4gl.mk
/opt/aubit4gl-rpm/incl/i4gl.mk


















#--end--

#Examples: (EXAMPFILE_x)
/opt/aubit4gl-rpm/tools/test/testmenu.menu
/opt/aubit4gl-rpm/tools/test/file.4gl
/opt/aubit4gl-rpm/tools/test/form.per
/opt/aubit4gl-rpm/tools/test/hello.4gl
/opt/aubit4gl-rpm/tools/test/hello_db.4gl
/opt/aubit4gl-rpm/tools/test/hello2.4gl
/opt/aubit4gl-rpm/tools/test/helpfile.msg
/opt/aubit4gl-rpm/tools/test/pdf_report.4gl
/opt/aubit4gl-rpm/tools/test/test_build.4gl
/opt/aubit4gl-rpm/tools/test/test_select.4gl
/opt/aubit4gl-rpm/tools/test/testmenu.4gl
/opt/aubit4gl-rpm/tools/test/assoc2.4gl
/opt/aubit4gl-rpm/tools/test/testmpz.4gl
/opt/aubit4gl-rpm/tools/test/make.bat
/opt/aubit4gl-rpm/tools/test/gui/gui.per
/opt/aubit4gl-rpm/tools/test/gui/calc.per
/opt/aubit4gl-rpm/tools/test/gui/form-gui.per
/opt/aubit4gl-rpm/tools/test/gui/gui.4gl
/opt/aubit4gl-rpm/tools/test/gui/calc.4gl
/opt/aubit4gl-rpm/tools/test/gui/hello-gui.4gl
/opt/aubit4gl-rpm/tools/test/gui/multi.per
/opt/aubit4gl-rpm/tools/test/gui/radio.per
/opt/aubit4gl-rpm/tools/test/gui/widget.per





































#--end--

#Makefiles: (MAKEFILE_x)
/opt/aubit4gl-rpm/tools/test/Makefile
/opt/aubit4gl-rpm/tools/test/gui/Makefile
/opt/aubit4gl-rpm/Makefile
/opt/aubit4gl-rpm/incl/Makefile-common
/opt/aubit4gl-rpm/incl/Makefile-install.mki
/opt/aubit4gl-rpm/incl/Makefile-common.in














#--end--

#Documentation files: (DOCFILE_x)
%doc /opt/aubit4gl-rpm/docs/changelog.txt
%doc /opt/aubit4gl-rpm/docs/COPYING
%doc /opt/aubit4gl-rpm/docs/CREDITS
%doc /opt/aubit4gl-rpm/docs/LICENSE
%doc /opt/aubit4gl-rpm/docs/aubit4gl.ico
%doc /opt/aubit4gl-rpm/docs/aubit4gl.png
%doc /opt/aubit4gl-rpm/docs/README-Windows.txt
%doc /opt/aubit4gl-rpm/README.txt












#--end--

#Configuration files: (CONFFILE_x)
/opt/aubit4gl-rpm/etc/gtkrc_2
/opt/aubit4gl-rpm/etc/odbc.ini.example
/opt/aubit4gl-rpm/etc/config/config.guess
/opt/aubit4gl-rpm/etc/config/config.sub
/opt/aubit4gl-rpm/etc/config/install-sh
/opt/aubit4gl-rpm/etc/config/missing
/opt/aubit4gl-rpm/etc/config/mkinstalldirs
/opt/aubit4gl-rpm/etc/config/bootstrap
/opt/aubit4gl-rpm/etc/config/ltmain.sh
/opt/aubit4gl-rpm/etc/aubitrc-bin.in
/opt/aubit4gl-rpm/install.sh









#--end--

#SQL conversion files: (CONVFILE_x)
/opt/aubit4gl-rpm/etc/convertsql/INFORMIX-DB2.cnv
/opt/aubit4gl-rpm/etc/convertsql/INFORMIX-DB2VM.cnv
/opt/aubit4gl-rpm/etc/convertsql/INFORMIX-INFORMIX.cnv
/opt/aubit4gl-rpm/etc/convertsql/INFORMIX-INGRES.cnv
/opt/aubit4gl-rpm/etc/convertsql/INFORMIX-MYSQL.cnv
/opt/aubit4gl-rpm/etc/convertsql/INFORMIX-MYSQLDIRECT.cnv
/opt/aubit4gl-rpm/etc/convertsql/INFORMIX-ORACLE.cnv
/opt/aubit4gl-rpm/etc/convertsql/INFORMIX-POSTGRES.cnv
/opt/aubit4gl-rpm/etc/convertsql/INFORMIX-POSTGRES8.cnv
/opt/aubit4gl-rpm/etc/convertsql/INFORMIX-POSTGRESQL.cnv
/opt/aubit4gl-rpm/etc/convertsql/INFORMIX-SQLITE.cnv
/opt/aubit4gl-rpm/etc/convertsql/INFORMIX-SQLSERVER.cnv
/opt/aubit4gl-rpm/etc/convertsql/ORACLE-INFORMIX.cnv
/opt/aubit4gl-rpm/etc/convertsql/POSTGRESQL-INFORMIX.cnv
/opt/aubit4gl-rpm/etc/convertsql/README.txt





#--end--

#Import files: (IMPORTFILE_x)
/opt/aubit4gl-rpm/etc/import/a4gl_file
/opt/aubit4gl-rpm/etc/import/a4gl_glade
/opt/aubit4gl-rpm/etc/import/a4gl_html
/opt/aubit4gl-rpm/etc/import/a4gl_pcre
/opt/aubit4gl-rpm/etc/import/a4gl_string
/opt/aubit4gl-rpm/etc/import/default
/opt/aubit4gl-rpm/etc/import/channel
/opt/aubit4gl-rpm/etc/import/README












#--end--

#HELPFILE: (HELPFILE_x)
/opt/aubit4gl-rpm/etc/helpfile.hlp
/opt/aubit4gl-rpm/etc/help_aubit.hlp
/opt/aubit4gl-rpm/etc/help_ecpg.hlp
/opt/aubit4gl-rpm/etc/help_sqlite.hlp
/opt/aubit4gl-rpm/etc/4glpc.hlp





#--end--

#FORMFILE: (FORMFILE_x)
/opt/aubit4gl-rpm/etc/change.afr.dat
/opt/aubit4gl-rpm/etc/options.afr.dat
/opt/aubit4gl-rpm/etc/values.afr.dat







#--end--

#4GLPC compile settings files
/opt/aubit4gl-rpm/tools/4glpc/settings/C
/opt/aubit4gl-rpm/tools/4glpc/settings/C_INFORMIX
/opt/aubit4gl-rpm/tools/4glpc/settings/EC
/opt/aubit4gl-rpm/tools/4glpc/settings/EC_INFOFLEX
/opt/aubit4gl-rpm/tools/4glpc/settings/EC_INFORMIX
/opt/aubit4gl-rpm/tools/4glpc/settings/EC_INGRES
/opt/aubit4gl-rpm/tools/4glpc/settings/EC_POSTGRES
/opt/aubit4gl-rpm/tools/4glpc/settings/EC_SAP
/opt/aubit4gl-rpm/tools/4glpc/settings/INFORMIX
/opt/aubit4gl-rpm/tools/4glpc/settings/PCODEC
/opt/aubit4gl-rpm/tools/4glpc/settings/mingw__EC_INFORMIX
/opt/aubit4gl-rpm/tools/4glpc/settings/mingw__EC_POSTGRES
/opt/aubit4gl-rpm/tools/4glpc/settings/x86_64-unknown-linux-gnu__C
/opt/aubit4gl-rpm/tools/4glpc/settings/x86_64-unknown-linux-gnu__EC
/opt/aubit4gl-rpm/tools/4glpc/settings/x86_64-unknown-linux-gnu__EC_INFORMIX
/opt/aubit4gl-rpm/tools/4glpc/settings/x86_64-unknown-linux-gnu__EC_POSTGRES




#--end--


#We do this in 'aubit' script:
#%_iconsdir/hicolor/*/apps/%rname.png
#%_datadir/applications/qt3-qtconfig.desktop

#%{RPM_A4GL_VERBOSE} "Finished processing 'files' section."

##############
%changelog
##############
#WARNING!!! RPM actually checks date format here !!

* Fri Nov 17 2006 afalout <andrej@falout.org>
- Abstract all pre/post tasks to 'aubit' wrapper scrip; this allows us to:
- Share same tasks ammong tarball, AutoPackage, deb and RPM installations
- Test and debug this functionality without having to circle trough package build cicles
- Have consistenf functionality and user interaction between installers
- Fix or change in one place and have it applied to all installers
- enable user interaction to be enabled or disabled without blocking installation
- satisfy RPm requirement for not requiring user interaction
- and many other nice things...
* Fri Nov 17 2006 afalout <andrej@falout.org>
- Make it build on SuSE 10.1
* Mon Jan 19 2004 afalout <andrej@falout.org>
- Make it all work again
* Wed Sep 17 2003 root <root@aptiva.falout.com>
- All files set from Autoconf
* Sun Aug 25 2002 root <root@aptiva.falout.com>
- Synchronised files between tarball and RPM
* Thu Dec 06 2001 root <root@aptiva.falout.com>
- Manually modified autospec version
* Thu Dec 06 2001 root <root@aptiva.falout.com>
- Initial spec file created by autospec ver. 0.6 with rpm 2.5 compatibility


##############
%pre
#is the macro to do pre-install scripts.
# NOTE: pre-x tasks cant be interactive without having to block RPM
#
#rpm automatically adjusts variable RPM_INSTALL_PREFIX[n] if package is relocated
#by user so we MUST use it to point to install location AND NOT VARIABLES WE
#DEFINED AT COMPILE TIME!
#
##############
if test "$RPM_INSTALL_PREFIX0" = ""; then
	CURR_A4GL_PREFIX=%{prefix}
else
	CURR_A4GL_PREFIX=$RPM_INSTALL_PREFIX0
fi
A4GL_TASK_MSG="Pre-Install"
A4GL_TASK_LOG="%{RPM_A4GL_RPMINSTALL_LOG}"
A4GL_AUBIT_FLAG="--pre-install-rpm --rpm-install-dir=${CURR_A4GL_PREFIX}"
A4GL_INTERACT_OPTION="--no-interaction  >> $A4GL_TASK_LOG"
A4GL_INTERACT_MSG="non-interactive program"


	#NOTE that ${CURR_A4GL_PREFIX} does not exist at this point

	#---------------------------------
	# Start task log file
	%{RPM_A4GL_VERBOSE} "NOTE: Logging $A4GL_TASK_MSG tasks to $A4GL_TASK_LOG"
	date > $A4GL_TASK_LOG

	#---------------------------------
	# Run task
	%{RPM_A4GL_VERBOSE} "Running aubit $A4GL_AUBIT_FLAG as $A4GL_INTERACT_MSG ..." >> $A4GL_TASK_LOG
	
	#we may want to do tasks in 'aubit --clean-machine' here ??
	
	%{RPM_A4GL_VERBOSE} "$A4GL_TASK_MSG tasks exited"  >> $A4GL_TASK_LOG

	#---------------------------------
	# Show to user task summary
	%{RPM_A4GL_VERBOSE} "$A4GL_TASK_MSG tasks finished, see $A4GL_TASK_LOG for details."


##############
%post
#is the macro to do post-install scripts.
##############
if test "$RPM_INSTALL_PREFIX0" = ""; then
	CURR_A4GL_PREFIX=%{prefix}
else
	CURR_A4GL_PREFIX=${RPM_INSTALL_PREFIX0}
fi
A4GL_TASK_MSG="Post-install"
A4GL_TASK_LOG="%{RPM_A4GL_RPMINSTALL_LOG}"
A4GL_AUBIT_FLAG="--post-install-rpm --rpm-install-dir=${CURR_A4GL_PREFIX}"

#Note that AutoConf warnings are printed to stderr
if test "%{A4GL_USER_INTERACTION}" = "1"; then
	A4GL_INTERACT_OPTION=">> $A4GL_TASK_LOG 2>&1 &"
	A4GL_INTERACT_MSG="interactive program in separate process"
else
	A4GL_INTERACT_OPTION="--no-interaction >> $A4GL_TASK_LOG 2>&1"
	A4GL_INTERACT_MSG="non-interactive program"
	A4GL_PLEASE_WAIT="echo 'Please wait ...'"
fi

	if ! test -d ${CURR_A4GL_PREFIX}; then
		%{RPM_A4GL_ERROR} "ERROR: CURR_A4GL_PREFIX (${CURR_A4GL_PREFIX}) is not a directory"
		%{RPM_A4GL_ERROR_EXIT} %{RPM_A4GL_ERROR_EXIT_CODE}
	fi
	
	#---------------------------------
	# Make sure we know where we are
	cd ${CURR_A4GL_PREFIX}

	#---------------------------------
	# Run task
	%{RPM_A4GL_VERBOSE} "Running aubit $A4GL_AUBIT_FLAG as $A4GL_INTERACT_MSG ..." >> $A4GL_TASK_LOG
	${A4GL_PLEASE_WAIT}
	eval ${CURR_A4GL_PREFIX}/bin/aubit $A4GL_AUBIT_FLAG $A4GL_INTERACT_OPTION
	%{RPM_A4GL_VERBOSE} "$A4GL_TASK_MSG tasks exited"  >> $A4GL_TASK_LOG

	#We do this in 'aubit' script:
	#/var/tmp/rpm-tmp.15057: line 64: fg: no job control
	#%post_ldconfig
	#%{RPM_A4GL_VERBOSE} "after post_ldconfig"

	#We do this in 'aubit' script:
	#/var/tmp/rpm-tmp.15057: line 66: fg: no job control
	#%update_menus
	#%{RPM_A4GL_VERBOSE} "after update_menus"
	
	#---------------------------------
	# Close log file
	%{RPM_A4GL_VERBOSE} "$A4GL_TASK_MSG tasks finished" >> $A4GL_TASK_LOG
	date >> $A4GL_TASK_LOG
	
	#---------------------------------
	# Show to user task summary
	%{RPM_A4GL_EXIT} "$A4GL_TASK_MSG tasks finished, see $A4GL_TASK_LOG for details."
	if test "%{A4GL_USER_INTERACTION}" = "1"; then
		%{RPM_A4GL_EXIT} "NOTE: configuration tasks are running in the background - please WAIT for them to finish before trying to use Aubit compiler. (~2 minutes)"
	fi

	
##############
%preun
# is the macro to do pre-uninstall scripts.
# NOTE: pre-x tasks cant be interactive without having to block RPM
##############
if test "$RPM_INSTALL_PREFIX0" = ""; then
	CURR_A4GL_PREFIX=%{prefix}
else
	CURR_A4GL_PREFIX=${RPM_INSTALL_PREFIX0}
fi
A4GL_TASK_MSG="Pre-Uninstall"
A4GL_TASK_LOG="%{RPM_A4GL_RPMDEINSTALL_LOG}"
A4GL_AUBIT_FLAG="--pre-uninstall-rpm --rpm-install-dir=${CURR_A4GL_PREFIX}"
A4GL_INTERACT_OPTION="--no-interaction >> $A4GL_TASK_LOG"
A4GL_INTERACT_MSG="non-interactive program"

	if ! test -d ${CURR_A4GL_PREFIX}; then
		%{RPM_A4GL_ERROR} "ERROR: CURR_A4GL_PREFIX (${CURR_A4GL_PREFIX}) is not a directory"
		%{RPM_A4GL_ERROR_EXIT} %{RPM_A4GL_ERROR_EXIT_CODE}
	fi

	#---------------------------------
	# Make sure we know where we are
	cd ${CURR_A4GL_PREFIX}

	#---------------------------------
	# Start task log file
	%{RPM_A4GL_VERBOSE} "NOTE: Logging $A4GL_TASK_MSG tasks to $A4GL_TASK_LOG"
	date > $A4GL_TASK_LOG

	#---------------------------------
	# Run task
	%{RPM_A4GL_VERBOSE} "Running aubit $A4GL_AUBIT_FLAG as $A4GL_INTERACT_MSG ..." >> $A4GL_TASK_LOG
	eval ${CURR_A4GL_PREFIX}/bin/aubit $A4GL_AUBIT_FLAG $A4GL_INTERACT_OPTION
	%{RPM_A4GL_VERBOSE} "$A4GL_TASK_MSG tasks exited"  >> $A4GL_TASK_LOG

	#---------------------------------
	# Show to user task summary
	%{RPM_A4GL_VERBOSE} "$A4GL_TASK_MSG tasks finished, see $A4GL_TASK_LOG for details."



##############
%postun
# macro to do post-uninstall scripts.
##############
if test "$RPM_INSTALL_PREFIX0" = ""; then
	CURR_A4GL_PREFIX=%{prefix}
else
	CURR_A4GL_PREFIX=${RPM_INSTALL_PREFIX0}
fi
A4GL_TASK_MSG="Post-Uninstall"
A4GL_TASK_LOG="%{RPM_A4GL_RPMDEINSTALL_LOG}"
A4GL_AUBIT_FLAG="--post-uninstall-rpm --rpm-install-dir=${CURR_A4GL_PREFIX}"
if test "%{A4GL_USER_INTERACTION}" = "1"; then
	A4GL_INTERACT_OPTION="&"
	A4GL_INTERACT_MSG="interactive program in separate process"
else
	A4GL_INTERACT_OPTION="--no-interaction  >> $A4GL_TASK_LOG"
	A4GL_INTERACT_MSG="non-interactive program"
fi
	
	if ! test -d ${CURR_A4GL_PREFIX}; then
		%{RPM_A4GL_VERBOSE} "ERROR: CURR_A4GL_PREFIX (${CURR_A4GL_PREFIX}) is not a directory"
		%{RPM_A4GL_ERROR_EXIT} %{RPM_A4GL_ERROR_EXIT_CODE}
	fi

	#NOTE that at this point all FILES are allready deleted
	
	#---------------------------------
	# Make sure we know where we are
	cd ${CURR_A4GL_PREFIX}

	#---------------------------------
	# Run tasks

	#We do this in 'aubit' script, in preunst:
	#Causes: /var/tmp/rpm-tmp.27103: line 36: fg: no job control
	#%postun_ldconfig
	#%clean_menus

	#Must be here, as 'aubit' script was allready deleted
	rmdir ${CURR_A4GL_PREFIX}/bin  ${CURR_A4GL_PREFIX}/docs 2>/dev/null
	rmdir ${CURR_A4GL_PREFIX}/etc/config  ${CURR_A4GL_PREFIX}/etc/convertsql  ${CURR_A4GL_PREFIX}/etc/import ${CURR_A4GL_PREFIX}/etc 2>/dev/null
	rmdir ${CURR_A4GL_PREFIX}/incl ${CURR_A4GL_PREFIX}/lib  2>/dev/null
	rmdir ${CURR_A4GL_PREFIX}/plugins-* 2>/dev/null
	rmdir ${CURR_A4GL_PREFIX}/tools/4glpc/settings ${CURR_A4GL_PREFIX}/tools/4glpc ${CURR_A4GL_PREFIX}/tools 2>/dev/null
	rmdir ${CURR_A4GL_PREFIX}/tools/test/gui ${CURR_A4GL_PREFIX}/tools/test ${CURR_A4GL_PREFIX}/test 2>/dev/null
	rmdir ${CURR_A4GL_PREFIX}/ 2>/dev/null
	
	#---------------------------------
	# Close log file 
	date >> $A4GL_TASK_LOG
	%{RPM_A4GL_VERBOSE} "$A4GL_TASK_MSG tasks finished" >> $A4GL_TASK_LOG	
	
	#---------------------------------
	# Show to user task summary
	%{RPM_A4GL_EXIT} "$A4GL_TASK_MSG tasks finished, see $A4GL_TASK_LOG for details."
	

##############
%verifyscript
# Tasks to perform as part of RPM verify command, after all files installed by
# RPM are verified
##############
if test "$RPM_INSTALL_PREFIX0" = ""; then
	CURR_A4GL_PREFIX=%{prefix}
else
	CURR_A4GL_PREFIX=${RPM_INSTALL_PREFIX0}
fi
A4GL_TASK_MSG="Post-Verify"
A4GL_TASK_LOG="%{RPM_A4GL_RPMVERIFY_LOG}"
A4GL_AUBIT_FLAG="--post-verify-rpm --rpm-install-dir=${CURR_A4GL_PREFIX}"
if test "%{A4GL_USER_INTERACTION}" = "1"; then
	A4GL_INTERACT_OPTION="&"
	A4GL_INTERACT_MSG="interactive program in separate process"
else
	A4GL_INTERACT_OPTION="--no-interaction  >> $A4GL_TASK_LOG"
	A4GL_INTERACT_MSG="non-interactive program"
fi

	if ! test -d ${CURR_A4GL_PREFIX}; then
		%{RPM_A4GL_ERROR} "ERROR: CURR_A4GL_PREFIX (${CURR_A4GL_PREFIX}) is not a directory"
		%{RPM_A4GL_ERROR_EXIT} %{RPM_A4GL_ERROR_EXIT_CODE}
	fi

	#---------------------------------
	# Make sure we know where we are
	cd ${CURR_A4GL_PREFIX}

	#---------------------------------
	# Start task log file
	%{RPM_A4GL_VERBOSE} "NOTE: Logging $A4GL_TASK_MSG tasks to $A4GL_TASK_LOG"
	date > $A4GL_TASK_LOG

	#---------------------------------
	# Run task
	%${RPM_A4GL_VERBOSE} "Running aubit $A4GL_AUBIT_FLAG as $A4GL_INTERACT_MSG ..." >> $A4GL_TASK_LOG
	${CURR_A4GL_PREFIX}/bin/aubit $A4GL_AUBIT_FLAG $A4GL_INTERACT_OPTION
	%{RPM_A4GL_VERBOSE} "$A4GL_TASK_MSG tasks exited"  >> $A4GL_TASK_LOG

	#---------------------------------
	# Close log file 
	date >> $A4GL_TASK_LOG
	%{RPM_A4GL_VERBOSE} "$A4GL_TASK_MSG tasks finished" >> $A4GL_TASK_LOG
	
	#---------------------------------
	# Show to user task summary
	%{RPM_A4GL_EXIT} "$A4GL_TASK_MSG tasks finished, see $A4GL_TASK_LOG for details."

	
#-------------------------------- EOF ----------------------------------

